Index: /trunk/contactcenter/inc/class.bo_contactcenter.inc.php
===================================================================
--- /trunk/contactcenter/inc/class.bo_contactcenter.inc.php	(revision 2)
+++ /trunk/contactcenter/inc/class.bo_contactcenter.inc.php	(revision 284)
@@ -5,5 +5,5 @@
   * Written by:                                                               *
   *  - Raphael Derosso Pereira <raphaelpereira@users.sourceforge.net>         *
-  *  sponsored by Thyamad - http://www.thyamad.com
+  *  sponsored by Thyamad - http://www.thyamad.com                            *
   * ------------------------------------------------------------------------- *
   *  This program is free software; you can redistribute it and/or modify it  *
@@ -25,10 +25,10 @@
 		*/
 		var $catalog;
-		
+
 		/*!
 			The Security Manager
 		*/
 		var $security;
-		
+
 
 		function bo_contactcenter($catalog=false)
@@ -37,5 +37,5 @@
 			$this->catalog_level = $GLOBALS['phpgw']->session->appsession('bo_contactcenter.catalog_level','contactcenter');
 			$this->security = CreateObject('contactcenter.bo_security_manager');
-			
+
 			if ($catalog)
 			{
@@ -56,12 +56,62 @@
 			}
 		}
-		
-		/*!
-		
+
+		/*
+		 *
+		 * @function is_external
+		 * @author Mário César Kolling <mario.kolling@serpro.gov.br>
+		 * @abstract Verify if a catalog is external
+		 * @param (mixed) an catalog array or a catalog tree level, a string in the form 0.sublevel.subsublevel
+		 * @return (boolean) true if it is an external catalog false otherwise
+		 *
+		 */
+
+		function is_external($catalog)
+		{
+			if (is_array($catalog))
+			{
+				$level = $this->get_level_by_branch($catalog, $this->tree['branches']);
+			}
+			else
+			{
+				$level = $catalog;
+			}
+
+			$lvl_vector = explode('.', $level);
+			$id = $lvl_vector[1];
+
+			if ($this->tree['branches'][$id]['external'])
+			{
+				return true;
+			}
+
+			return false;
+
+		}
+
+		/*
+		 function get_letters_filter($catalog)
+		{
+
+		}
+
+		function get_numbers_filter($catalog)
+		{
+
+		}
+
+		function get_search_filter($catalog)
+		{
+
+		}
+		*/
+
+		/*!
+
 			@function find
 			@abstract Performs a search in the DB based on the parameters
 			@author Raphael Derosso Pereira (algorithm and code)
 			@author Vinicius Cubas Brand (algorithm)
-			
+
 			@param array $what The list of fields to be returned. The format is:
 				$what = array(
@@ -69,16 +119,16 @@
 					'contact.names_ordered'
 				);
-			
+
 			@param array $rules The restrictions.
-			
+
 			The restrictions format is quite complicated, but is very complete.
 			As defined here, there is the possibility to do almost any type of
 			search (tell me if you can't do any). For example, imagine the
 			following search:
-					
+
 						and(a,or(d,e,and(f,g)))
-			
+
 			That is represented by the folloowing tree:
-				
+
                                    and
                                     |
@@ -98,5 +148,5 @@
 			The rules that should be passed to the find function for this tree
 			is:
-				
+
 	 			$rules = array(
  					0 => array(
@@ -139,10 +189,10 @@
 	 			);
 
-  
-			The restriction type can be: =, !=, <=, <, >, >=, NULL, IN, LIKE, 
+
+			The restriction type can be: =, !=, <=, <, >, >=, NULL, IN, LIKE,
 			NOT NULL, NOT IN, NOT LIKE
 			Value of branch can be AND, OR, NOT
-			
-			@param array $other Other parameter to the search 
+
+			@param array $other Other parameter to the search
 				$other = array(
 					'offset'          => (int),
@@ -154,5 +204,5 @@
 
 			@return array $array[<field_name>][<row_number>]
-				
+
 		*/
 		function find($what, $rules=false, $other=false)
@@ -160,7 +210,7 @@
 			return $this->catalog->find($what, $rules, $other);
 		}
-		
-		/*!
-		
+
+		/*!
+
 			@function get_catalog_tree
 			@abstract Returns an array describing the available
@@ -168,9 +218,10 @@
 				values and types
 			@author Raphael Derosso Pereira
+			@author Mário César Kolling (external catalogs and optimizations)
 
 			@param (string)  $level The level to be taken
 			@param (boolean) $recursive Retrive the whole tree from
 				the level specified until the leaves
-			
+
 			@return The format of the return is:
 				$return = array(
@@ -195,7 +246,7 @@
 					1  => array(...),...
 				);
-				
+
 				<branch_type> can be 'catalog_group', 'catalog' or 'view';
-				<branch_class> is the name of the class that is capable of 
+				<branch_class> is the name of the class that is capable of
 					handling the information for this catalog/view
 				<branch_class_args> is an array that holds the arguments to
@@ -203,8 +254,8 @@
 				<brach_find_args> is the string that should precede the search
 					string
-						
-				If the branch is actually a leaf, than 'sub_branch' is false; 
-		
-		
+
+				If the branch is actually a leaf, than 'sub_branch' is false;
+
+
 			TODO: This method is hard-coded, but it should grab the tree
 			from the DB using the View Manager...
@@ -218,8 +269,11 @@
 					return $this->tree['branches'];
 				}
-				
+
+				$lvl_vector = explode('.', $level);
+				$id = $lvl_vector[1];
+
 				$branch =& $this->get_branch_by_level($level);
 				$info = $this->get_info_by_level($level);
-				
+
 				if ($branch['type'] === 'unknown')
 				{
@@ -227,9 +281,28 @@
 					{
 						$ldap = CreateObject('contactcenter.bo_ldap_manager');
-						$new_branch = $ldap->get_ldap_tree($info['src'], $branch['value'], $recursive);
-						
+
+						if ($this->tree['branches'][$id]['external'])
+						{
+							// if it's an external catalog
+							$new_branch = $ldap->get_external_ldap_tree($info['src'], $branch['value'], $recursive);
+						}
+						else
+						{
+							// if it's not an external catalog
+							$new_branch = $ldap->get_ldap_tree($info['src'], $branch['value'], $recursive);
+						}
+
 						if ($new_branch)
 						{
+							if (!empty($new_branch['timeout']) && !empty($new_branch['msg']))
+							{
+								return $new_branch;
+							}
+
+							// Necessary for the new way the catalog tree is built at initialization
+							$new_branch['name'] = $branch['name'];
+							$new_branch['external'] = $branch['external'];
 							$branch = $new_branch;
+
 						}
 						else
@@ -239,5 +312,4 @@
 					}
 					$GLOBALS['phpgw']->session->appsession('bo_contactcenter.tree','contactcenter',$this->tree);
-					
 					return $branch;
 				}
@@ -246,13 +318,13 @@
 					return $branch;
 				}
-				
+
 				return false;
 			}
-			
+
 			if ($level !== '0')
 			{
 				return false;
 			}
-			
+
 			$this->tree = array(
 				0 => array(
@@ -275,5 +347,5 @@
 						'sub_branch' => false
 					),*/
-					
+
 					1  => array(
 						'name'       => lang('Groups'),
@@ -281,12 +353,12 @@
 						'class'      => 'bo_group_manager',
 						'icon'       => 'people-mini.png',
-						'sub_branch' => False   
+						'sub_branch' => False
 					)
 				)
 			);
-			
+
 			$ldap = CreateObject('contactcenter.bo_ldap_manager');
 			$ldap_srcs = $ldap->get_all_ldap_sources();
-			
+
 			if ($ldap_srcs)
 			{
@@ -297,25 +369,93 @@
 					if (($tree = $ldap->get_ldap_tree($id, $ldap_srcs[$id]['dn'], $recursive)))
 					{
+						// It isn't used anymore, but does no harm!
+						// It may be usefull later for use with search timeouts, or another ldap error
+						if (array_key_exists('error_msg', $tree))
+						{
+							if (isset($this->tree['branches']['msg']))
+							{
+								$this->tree['branches']['msg'] .= "\n" . lang('Catalog %1 not showed due to error: ' .
+													 $tree['error_msg'], $ldap_srcs[$id]['name']);
+							}
+							else
+							{
+								$this->tree['branches']['msg'] = lang('Catalog %1 not showed due to error: ' .
+													 $tree['error_msg'], $ldap_srcs[$id]['name']);
+							}
+						}
+						else
+						{
+							$tree['name'] = $ldap_srcs[$id]['name'];
+							$tree['external'] = false;
+							array_push($this->tree['branches'], $tree);
+							$this->tree[$i]['type'] = 'ldap';
+							$this->tree[$i]['src'] = $id;
+						}
+
+					}
+					$i++;
+				}
+			}
+
+			// external LDAP sources
+			$ldap_srcs = $ldap->get_external_ldap_sources();
+
+			if ($ldap_srcs)
+			{
+				$i = count($this->tree);
+
+				reset($ldap_srcs);
+
+				while (list($id,) = each($ldap_srcs))
+				{
+					// External catalogs are now identified as type unknown during initialization. An optimization change.
+
+					/*
+					if (($tree = $ldap->get_external_ldap_tree($id, $ldap_srcs[$id]['dn'], $recursive)))
+					{
+						if (array_key_exists('error_msg', $tree))
+						{
+							if (isset($this->tree['branches']['msg']))
+							{
+								$this->tree['branches']['msg'] .= "\n" . lang('Catalog %1 not showed due to error: ' .
+													 $tree['error_msg'], $ldap_srcs[$id]['name']);
+							}
+							else
+							{
+								$this->tree['branches']['msg'] = lang('Catalog %1 not showed due to error: ' .
+													 $tree['error_msg'], $ldap_srcs[$id]['name']);
+							}
+						}
+
+						else
+						{
+						*/
 						$tree['name'] = $ldap_srcs[$id]['name'];
+						$tree['type'] = 'unknown';
+						$tree['value'] = $ldap_srcs[$id]['dn'];
+						$tree['external'] = true;
+						//$tree['sub_branch'] = false;
 						array_push($this->tree['branches'], $tree);
 						$this->tree[$i]['type'] = 'ldap';
 						$this->tree[$i]['src'] = $id;
-					}
+					//	}
+					//}
 					$i++;
 				}
 			}
-			
+
 			$GLOBALS['phpgw']->session->appsession('bo_contactcenter.tree','contactcenter',$this->tree);
 			return $this->tree['branches'];
-		}
-
-		/*!
-			
+			//return null;
+		}
+
+		/*!
+
 			@function get_branch_by_level
 			@abstract Returns the branch and it's informations given the level
 			@author Raphael Derosso Pereira
-			
+
 			@param (string) $level The level to be used
-			
+
 		*/
 		function & get_branch_by_level($level)
@@ -323,10 +463,10 @@
 			$path = @explode('.',$level);
 			$n_ways = count($path);
-			
+
 			if ($n_ways <= 1)
 			{
 				return false;
 			}
-			
+
 			$code = '$branch =& $this->tree[\'branches\']';
 			for ($i = 1; $i < $n_ways-1; $i++)
@@ -338,10 +478,10 @@
 			//echo 'Codigo: '.$code.'<br>';
 			eval($code);
-			
+
 			return $branch;
 		}
 
 		/*!
-		 
+
 		 @function get_info_by_level
 		 @abstract Returns the information about the catalog, given the level
@@ -355,12 +495,12 @@
 			$path = @explode('.',$level);
 			$n_ways = count($path);
-			
+
 			if ($n_ways <= 1)
 			{
 				return false;
 			}
-			
+
 			$info = $this->tree[$path[1]];
-			
+
 			return $info;
 		}
@@ -413,5 +553,5 @@
 
 					$search = $this->get_level_by_branch($catalog, $bcatalog['sub_branch'], (string) $level);
-					
+
 					if ($search !== false)
 					{
@@ -427,13 +567,13 @@
 			return false;
 		}
-		
-		/*!
-		
+
+		/*!
+
 			@function get_actual_catalog
-			@abstract Returns the information about the Catalog that is 
+			@abstract Returns the information about the Catalog that is
 				instantiated
 
 			@author Raphael Derosso Pereira
-		
+
 		*/
 		function get_actual_catalog()
@@ -442,14 +582,14 @@
 			return $catalog;
 		}
-		
-		/*!
-		
+
+		/*!
+
 			@function set_catalog
 			@abstract Sets the actual catalog
 			@author Raphael Derosso Pereira
-			
+
 			@param array $to_catalog The catalog in the format returned by
 				get_available_tree or the level
-		
+
 		*/
 		function set_catalog(& $to_catalog )
@@ -477,5 +617,8 @@
 				$level = $this->get_level_by_branch($to_catalog, $this->tree['branches']);
 			}
-			
+
+			$lvl_vector = explode('.', $level);
+			$id = $lvl_vector[1];
+
 			switch($catalog['type'])
 			{
@@ -499,18 +642,18 @@
 						$call .= ','.implode(',',$args);
 					}
-					
+
 					$call .= ');';
-					
+
 //					print_r($catalog);
 //					echo '<br><br><b>Setando Catalogo '.$catalog['name'].': </b>'.$call.'<br>';
 
 					eval($call);
-								
+
 					return $catalog;
-					
+
 				default: return false;
 			}
 		}
-		
+
 
 
@@ -518,7 +661,7 @@
 		 *                Methods to set general fields                      *
 		\*********************************************************************/
-		
-		/*!
-		
+
+		/*!
+
 			@function add_vcard
 			@abstract Insert a VCard to the squema
@@ -526,5 +669,5 @@
 			@param string $uploaded_file The path to the file that were
 				uploaded.
-		
+
 		*/
 		function add_vcard ( $uploaded_file )
@@ -533,9 +676,9 @@
 
 
-		
+
 		/*********************************************************************\
 		 *                Methods to get general data                        *
 		\*********************************************************************/
-		
+
 	}
 ?>
Index: /trunk/contactcenter/js/cc_tree.js
===================================================================
--- /trunk/contactcenter/js/cc_tree.js	(revision 56)
+++ /trunk/contactcenter/js/cc_tree.js	(revision 284)
@@ -20,5 +20,5 @@
 		throw('dFTree lib must be loaded!');
 	}
-	
+
 	function ccCatalogTree(params)
 	{
@@ -29,5 +29,5 @@
 
 		var _tree = this;
-		
+
 		/* This is the property that holds the Tree Object */
 		this.name = params['name'];
@@ -39,5 +39,5 @@
 		this.Connector = params['connector'];
 
-		/* Build the Inicial Tree */ 
+		/* Build the Inicial Tree */
 		//this._getActualLevel();
 		setTimeout(function(){ _tree._updateTree('0', true);}, 100);
@@ -57,5 +57,5 @@
 				return;
 			}
-			
+
 			if (data['status'] != 'ok')
 			{
@@ -66,5 +66,5 @@
 
 			_this.catalog_perms = parseInt(data['perms']);
-			
+
 			if (_this.afterSetCatalog)
 			{
@@ -75,7 +75,7 @@
 		Connector.newRequest(this.name+'catalog', CC_url+'set_catalog&catalog='+catalog, 'GET', handler);
 	}
-	
+
 	ccCatalogTree.prototype.setCatalogSearch = function (catalog) {
-	
+
 		var _this = this;
 		var handler = function (responseText)
@@ -89,5 +89,5 @@
 				return;
 			}
-			
+
 			if (data['status'] != 'ok')
 			{
@@ -100,17 +100,17 @@
 
 			this.afterSetCatalog = ccEmailWin.search.go();
-			
+
 		};
 
 		Connector.newRequest(this.name+'catalog', CC_url+'set_catalog&catalog='+catalog, 'GET', handler);
 	}
-		
-	
+
+
 	ccCatalogTree.prototype.select = function(level, search)
 	{
-		if (!search) { 
+		if (!search) {
 			this.tree.openTo(level);
 			this.tree.getNodeById(level)._select();
-		
+
 			if (level != this.actualLevel)
 			{
@@ -129,5 +129,5 @@
 	 *                    Methods For Internal Use                           *
 	\*************************************************************************/
-	
+
 	ccCatalogTree.prototype._waitForTree = function(level, rlevel)
 	{
@@ -142,5 +142,5 @@
 			return;
 		}
-		
+
 		setTimeout(this.name+'._waitForTree(\''+level+'\', '+rlevel+')', 100);
 	}
@@ -176,31 +176,10 @@
 				_this.tree.getNodeById(_this.actualLevel)._select();
 				_this.setCatalog(_this.actualLevel);
-				_this.expandTree();
-
-			}
-		};
-		
+			}
+		};
+
 		Connector.newRequest(this.name+'actual', CC_url+'get_actual_catalog', 'GET', handler);
 	}
 
-	ccCatalogTree.prototype.expandTree = function() {
-		for (i=0; i < this.tree._aNodes.length; i++)
-			this._expandSubTree(this.tree._aNodes[i]);
-	}
-
-	ccCatalogTree.prototype._expandSubTree = function(node) {
-		if ( node._children == '' ) {
-			return;
-		}
-		if (node._children != '') {
-			for (i = 0; i <= node._children.length; i++) {
-				if ( node._io == false )
-					node.changeState();
-				this._expandSubTree(node._children[i]);
-			}
-		}
-	}
-
-
 	ccCatalogTree.prototype._updateTree = function(level, open)
 	{
@@ -222,9 +201,12 @@
 			{
 				showMessage(data['msg']);
-				return;
+				if (data['status'] != 'error')
+				{
+					return;
+				}
 			}
 
 			treeData = data['data'];
-			
+
 			var timeout = 10;
 			var limit = 0;
@@ -261,5 +243,5 @@
 				timeout += 5;
 			}
-			
+
 			_this.treeAvailable = true;
 
@@ -271,4 +253,5 @@
 			}
 		};
+
 		Connector.newRequest(this.name+'update', CC_url+'get_catalog_tree&level='+level, 'GET', handler);
 	}
Index: /trunk/contactcenter/js/ccQuickAddContact.js
===================================================================
--- /trunk/contactcenter/js/ccQuickAddContact.js	(revision 118)
+++ /trunk/contactcenter/js/ccQuickAddContact.js	(revision 284)
@@ -6,12 +6,12 @@
 	}
 
-	
+
 	cQuickAddContact.prototype.showList = function(id){
 		_this = this;
 		var handler = function (responseText) {
 			var contacts = unserialize(responseText);
-			var title = contacts['names_ordered'];			
-			el = document.createElement("DIV");									
-			el.style.visibility = "hidden";									
+			var title = contacts['names_ordered'];
+			el = document.createElement("DIV");
+			el.style.visibility = "hidden";
 			el.style.position = "absolute";
 			el.style.left = "0px";
@@ -21,29 +21,40 @@
 			el.style.height = wHeight + 'px';
 			el.className = "div_cc_rectQuickAddContact";
-			el.id = id+':cc_rectQuickAddContact';																							
-			document.body.appendChild(el);																
-			el.innerHTML = "";								
+			el.id = id+':cc_rectQuickAddContact';
+			document.body.appendChild(el);
+			el.innerHTML = "";
 
 			var fieldsTop = 10;
 			var fieldsSpace = 30;
 			fields = new Array(Element('cc_qa_alias').value, Element('cc_qa_given_names').value, Element('cc_qa_family_names').value, Element('cc_qa_phone').value, Element('cc_qa_email').value);
-			
+
 			for (i=0; i<fields.length; i++) {
 				var contact = contacts[i] != null ? contacts[i] : '';
 				el.innerHTML += '<span id="ccQuickAddCT' + i + id + '" style="position: absolute; top: ' +  (fieldsTop+i*fieldsSpace) + 'px; left: 5px; width: 100px; text-align: right; border: 0px solid #999;">' + fields[i] + '</span>';
-				el.innerHTML += '<input id="ccQuickAddCI' + i + id + '" type="text" value="' + contact + '" maxlength="50" style="position: absolute; top: ' + (fieldsTop+i*fieldsSpace) + 'px; left: 110px; width: 135px;">';
+				if (i == 0)
+				{
+					el.innerHTML += '<input id="ccQuickAddCI' + i + id + '" type="text" value="' + contact + '" maxlength="30" style="position: absolute; top: ' + (fieldsTop+i*fieldsSpace) + 'px; left: 110px; width: 135px;">';
+				}
+				else if (i == 4)
+				{
+					el.innerHTML += '<input id="ccQuickAddCI' + i + id + '" type="text" value="' + contact + '" maxlength="100" style="position: absolute; top: ' + (fieldsTop+i*fieldsSpace) + 'px; left: 110px; width: 135px;">';
+				}
+				else
+				{
+					el.innerHTML += '<input id="ccQuickAddCI' + i + id + '" type="text" value="' + contact + '" maxlength="50" style="position: absolute; top: ' + (fieldsTop+i*fieldsSpace) + 'px; left: 110px; width: 135px;">';
+				}
 			}
-			
+
 			el.innerHTML +='<div id="ccQAFuncitons" style="border: 0px solid black; width: 220px; height: 20px">' +
-				'<input title="' + Element('cc_qa_save').value + '"  type="button" onclick="ccQuickAddContact.send(\'' + id + '\');" value="' + Element('cc_qa_save').value + '" style="position: absolute; top: ' + (fieldsTop+i*fieldsSpace) + 'px; left: 75px; width: 60px" />' +
-				'<input title="' + Element('cc_qa_close').value + '" type="button" onclick="ccQuickAddContact.fechar(\'' + id + '\');" value="' + Element('cc_qa_close').value + '" style="position: absolute; top: ' + (fieldsTop+i*fieldsSpace) + 'px; left: 140px; width: 60px" />' +
+				'<input title="ccQASave" type="button" onclick="ccQuickAddContact.send(\'' + id + '\');" value="' + Element('cc_qa_save').value + '" style="position: absolute; top: ' + (fieldsTop+i*fieldsSpace) + 'px; left: 75px; width: 60px" />' +
+				'<input title="ccQAClear" type="button" onclick="ccQuickAddContact.fechar(\'' + id + '\');" value="' + Element('cc_qa_clear').value + '" style="position: absolute; top: ' + (fieldsTop+i*fieldsSpace) + 'px; left: 140px; width: 60px" />' +
 				'</div>';
 			el.innerHTML +=	"<br>";
-								
+
 			_this.showWindow(el);
 		}
-		
+
 		div = document.getElementById(id+':cc_rectQuickAddContact');
-				
+
 		if(div)
 			this.showWindow(div);
@@ -52,10 +63,10 @@
 		}
 	}
-	
+
 	cQuickAddContact.prototype.showWindow = function (div)
-	{						
+	{
 		if(! this.arrayWin[div.id]) {
 
-			win = new dJSWin({			
+			win = new dJSWin({
 				id: 'ccQuickAddContact_'+div.id,
 				content_id: div.id,
@@ -64,18 +75,18 @@
 				title_color: '#3978d6',
 				bg_color: '#eee',
-				title: Element('ccQATitle').value,						
+				title: Element('ccQATitle').value,
 				title_text_color: 'white',
 				button_x_img: Element('cc_phpgw_img_dir').value+'/winclose.gif',
 				border: true });
-			
+
 			this.arrayWin[div.id] = win;
-			win.draw();			
+			win.draw();
 		}
 		else {
 			win = this.arrayWin[div.id];
-		}			
+		}
 		win.open();
 	}
-	
+
 	cQuickAddContact.prototype.send = function (id)
 	{
@@ -104,5 +115,5 @@
 				return;
 			}
-			
+
 			win.close();
 
@@ -121,11 +132,11 @@
 			}
 		}
-	
+
 		var sdata = new Array();
-		
+
 		for (var f = 0; f < 5; f++){
 			sdata[f] = document.getElementById('ccQuickAddCI' + f + id).value;
 		}
-		
+
 		//Utiliza expressão regular para validar email
 		var reEmail = /^[A-Za-z\d_-]+(\.[A-Za-z\d_-]+)*@(([A-Za-z\d][A-Za-z\d-]{0,61}[A-Za-z\d]\.)+[A-Za-z]{2,6}|\[\d{1,3}(\.\d{1,3}){3}\])$/;
@@ -136,27 +147,27 @@
 			return false;
 		}
-		
+
 		//Utiliza expressão regular para validar telefone
 		var rePhone = /^[0-9|(-)| |-]{0,15}$/;
-		
+
 		if (!rePhone.test(sdata[3])){
 			alert("O número de telefone '" + sdata[3] + "' não é valido! Utilize apenas números.\n" +
 			"Parenteses, traços ou espaços em branco podem ser usados como carácter separador.");
 			return false;
-		} 
-		
+		}
+
 		var sdata = 'add='+escape(serialize(sdata));
 
 		Connector.newRequest('cQuickAdd.Send', CC_url+'quick_add', 'POST', handler, sdata);
 	}
-	
+
 	cQuickAddContact.prototype.fechar = function(id) {
-	
+
 		div = document.getElementById(id+':cc_rectQuickAddContact');
 		win = this.arrayWin[div.id];
 		win.close();
 	}
-	
-	
+
+
 /* Build the Object */
 	var ccQuickAddContact ;
@@ -164,10 +175,10 @@
 
 	if (is_ie)
-	{ 
-		document.body.onload = function (e) 
-		{ 
+	{
+		document.body.onload = function (e)
+		{
 			cQuickAddContact_pre_load();
 			ccQuickAddContact = new cQuickAddContact();
-			
+
 		};
 	}
Index: /trunk/contactcenter/js/cc_search.js
===================================================================
--- /trunk/contactcenter/js/cc_search.js	(revision 2)
+++ /trunk/contactcenter/js/cc_search.js	(revision 284)
@@ -60,5 +60,5 @@
 		this.DOMinput.value = params['value'] ? params['value'] : '';
 		this.DOMinput.style.width = params['input_width'] ? params['input_width'] : '200px';
-		this.DOMinput.onkeypress = function (e) { 
+		this.DOMinput.onkeypress = function (e) {
 				if (is_ie)
 				{
@@ -86,5 +86,5 @@
 		if (params['progress_color'])
 			this.DOMprogHold.style.color = params['progress_color'];
-		
+
 		this.DOMresult.style.position = 'absolute';
 		this.DOMresult.style.top = params['progress_top'] ? params['progress_top'] : '0px';
@@ -96,5 +96,5 @@
 			this.DOMresult.style.color = params['progress_color'];
 
-		this.DOMholder.appendChild(this.DOMdiv);	
+		this.DOMholder.appendChild(this.DOMdiv);
 		this.DOMdiv.appendChild(this.DOMfields);
 		this.DOMdiv.appendChild(this.DOMinput);
@@ -104,36 +104,136 @@
 		this.DOMdiv.appendChild(this.DOMresult);
 	}
-	
+
 	ccSearchClass.prototype.go = function()
 	{
 		var data = new Array();
-		
+
 		this.DOMresult.innerHTML = '';
 
 		//TODO: Make Generic!
 		var type = Element('cc_type_contact').value;
-		
+
 		data['fields']           = new Array();
-		
+
 		if (type == 'groups') {
-			data['fields']['id']     = 'group.id_group';			
+			data['fields']['id']     = 'group.id_group';
 			data['fields']['search'] = 'group.title';
-		}		
-		else {			
-			data['fields']['id']     = 'contact.id_contact';		
-			data['fields']['search'] = 'contact.names_ordered';					
-		}
-		
+		}
+		else {
+			data['fields']['id']     = 'contact.id_contact';
+			data['fields']['search'] = 'contact.names_ordered';
+		}
+
 		data['search_for']       = this.DOMinput.value;
 		//data['recursive']        = this.recursive.checked ? true : false;
-		
+		// Exige que a consulta por nome seja feita com no mínimo 4 caracteres
+		var search_for = data['search_for'].split(' ');
+		var greaterThan4 = false;
+
+		for (i = 0; i < search_for.length; i++)
+		{
+			if (search_for[i].length >= 4)
+			{
+				greaterThan4 = true;
+			}
+		}
+
+		if (!greaterThan4){
+			alert("Favor fazer a consulta com pelo menos 4 caracteres!");
+			return;
+		}
+
 		var _this = this;
 
+	var handler = function (responseText)
+	{
+		var data = new Array();
+		data = unserialize(responseText);
+
+		ccSearchUpdate();
+
+		letter = 'search';
+
+		if ( letter != CC_actual_letter )
+		{
+			CC_actual_page = '1';
+		}
+		else
+		{
+			CC_actual_page = parseInt(data[1]);
+		}
+
+		CC_actual_letter = letter;
+
+		if (CC_max_cards[0] == 0)
+		{
+
+			if(CC_visual == 'cards')
+				drawCards(0);
+			else if(CC_visual == 'table')
+				drawTable(0);
+
+			setPages(0,0);
+			return;
+		}
+
+		if (data[0] == '0')
+		{
+			Element('cc_type_contact').value = data[1];
+			CC_npages = 0;
+			CC_actual_page = 1;
+			if(CC_visual == 'cards')
+				drawCards(0);
+			else if(CC_visual == 'table')
+				drawTable(0);
+			setPages(0,0);
+			return;
+		}
+		else
+		{
+			Element('cc_type_contact').value = data[10];
+		}
+
+//		Element('cc_debug').innerHTML = responseText;
+
+		if (typeof(data) != 'object')
+		{
+			showMessage(Element('cc_msg_err_contacting_server').value);
+			return;
+		}
+
+		if (typeof(data[3]) == 'object')
+		{
+			CC_npages = parseInt(data[0]);
+			CC_actual_page = parseInt(data[1]);
+			if(CC_visual == 'cards')
+				drawCards(data[3].length, data[10]);
+			else if(CC_visual == 'table')
+				drawTable(data[3].length, data[10]);
+			resizeWindow();
+			populateCards(data, data[10]);
+			setPages(data[0], data[1]);
+		}
+		else if (data['error'])
+		{
+			showMessage(data['error']);
+		}
+		else
+		{
+			showMessage(Element('cc_msg_err_contacting_server').value);
+			return;
+		}
+
+
+	};
+
+
+/*
 		var handler = function (responseText)
 		{
 			Element('cc_debug').innerHTML = responseText;
-			
+
 			var data = unserialize(responseText);
-			
+
 			if (!data || !data['status'])
 			{
@@ -147,5 +247,5 @@
 				_this.DOMresult.innerHTML = data['msg'];
 				setTimeout(function(){_this.DOMresult.innerHTML = '';}, 1000);
-				
+
 				if (_this.onSearchFinish)
 				{
@@ -163,5 +263,13 @@
 			}
 
-			//showMessage(data['msg']);
+			// Mostra a mensagem se a busca retornar mais de 300 resultados.
+			if (data['data'].length > 300)
+			{
+
+				TODO: Usar o esquema de tradução do expresso para este alert
+
+				alert("Mais de 300 resultados foram retornados!\n" +
+					"Favor refinar sua busca.");
+			}
 
 			if (_this.onSearchFinish)
@@ -170,5 +278,6 @@
 			}
 		};
-		
-		this.Connector.newRequest('search', CC_url+'search&data='+serialize(data), 'GET', handler);
+*/
+		var info = "letter="+'search'+"&page="+'1'+"&data="+serialize(data);
+		this.Connector.newRequest('get_cards_data', CC_url+'get_cards_data', 'POST', handler, info);
 	}
Index: /trunk/contactcenter/js/ccAddGroup.js
===================================================================
--- /trunk/contactcenter/js/ccAddGroup.js	(revision 118)
+++ /trunk/contactcenter/js/ccAddGroup.js	(revision 284)
@@ -158,5 +158,5 @@
 		
 		if(!this.title.value) {
-			alert(Element('cc_msg_fill_field_name').value);
+			alert('Preencha o campo obrigatório "Nome Completo"');
 			this.title.focus();
 			return false;
@@ -164,5 +164,5 @@
 				
 		if(! contacts.length) {
-			alert(Element('cc_msg_add_contact_to_group').value);
+			alert('Você não adicionou nenhum contato para esse grupo');
 			return false;
 		}
